unit data_m;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TDATA_MAT = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    pliki: TFileListBox;
    katalogi: TDirectoryListBox;
    LISTA_PLIKOW: TListBox;
    procedure FormShow(Sender: TObject);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  type
    bin = array [1..8] of boolean;
var
  DATA_MAT: TDATA_MAT;
  czerwony,zielony,niebieski: byte;
  function Na_Dziesietne(binarny: bin): integer; {szybki tryb omiobitowy}
  function Na_Binarne(bajt: integer): bin; {szybki tryb omiobitowy}
function potega(liczba:integer; wykladnik:integer): integer;
    function sama_nazwa_pliku(sciezka : ansistring): ansistring;
    function sama_nazwa_katalogu(sciezka : ansistring): ansistring;
    function duze_litery_PL(wers: ansistring): ansistring;
    function male_litery_PL(wers: ansistring): ansistring;
    function rozpoznaj_rozszerzenie_pliku(sciezka: ansistring): ansistring;
    function plik_bez_rozszerzenia(ciag: ansistring): ansistring;
    function Podaj_sciezke_tego_programu: ansistring;
    function sprawdz_dostep_do_pliku(sciezka: ansistring): boolean;
    function rozmiar_pliku(sciezka: ansistring): cardinal;
    function Sprawdz_czy_sciezka_bezwzgledna(sciezka: ansistring): boolean;
    Procedure Podaj_rgb(kolor: longint);
    procedure Szukaj_w_katalogu(miejsce,nazwa: ansistring);
    function Obrob_katalog(dest: ansistring): ansistring;
    function szukaj_w_ciagu(slowo_k: ansistring;ciag: ansistring): boolean;
    procedure Szukaj_plikow_z_trescia(tresc,katalog: ansistring);


  implementation

{$R *.DFM}

procedure Tdata_mat.FormShow(Sender: TObject);
begin
  DATA_MAT.Left := (screen.width - data_mat.width) div 2;
  DATA_MAT.top := (screen.height - data_mat.height) div 2;
end;

function potega(liczba:integer; wykladnik:integer): integer;
var
  wynik,i : integer;
begin
  wynik := liczba;
  for i := 2 to wykladnik do
  begin
    wynik := wynik * liczba;
  end;
  if wykladnik = 0 then wynik := 1;
  if wykladnik = 1 then wynik := liczba;
  potega := wynik;
end;

function Na_Dziesietne(binarny: bin): integer;
var
  obliczam: integer;
  bit,i: byte;
begin
  obliczam := 0;
  for i := 0 to 7 do
  begin
  if binarny[i+1] = true then
  bit := 1 else bit := 0;
  obliczam := obliczam + (potega(2,7-i)*bit);
  end;
  Na_Dziesietne := obliczam;
end;

function Na_Binarne(bajt: integer): bin;
var
 t: bin;
 reszta,i: integer;
 wynik, bajtp : integer;
 b: byte;
begin
  for b := 1 to 8 do t[b] := false;
  bajtp := bajt;
  b := 9;
  repeat
  begin
    Dec(b);
    wynik := bajtp div 2; reszta := bajtp mod 2;
    bajtp := wynik; if reszta > 0 then t[b] := true else
    t[b] := false;
  end; until wynik = 0;
  Na_Binarne := t;
end;


function sama_nazwa_pliku(sciezka : ansistring): ansistring;
var
  i,h: cardinal; sama_n: ansistring;
begin
sama_n := '';
i := Length(sciezka);
repeat
i := i - 1;
until (sciezka[i] = '\') or (sciezka[i] = '/') or (i = 1);
if (sciezka[i] = '\') or (sciezka[i] = '/') then i := i + 1;
for h := i to Length(sciezka) do
sama_n := sama_n + sciezka[h];
sama_nazwa_pliku := sama_n;
end;

function sama_nazwa_katalogu(sciezka : ansistring): ansistring;
var
  i,h: cardinal; sama_n: ansistring;
begin
sama_n := '';
i := Length(sciezka);
repeat
i := i - 1;
until (sciezka[i] = '\') or (sciezka[i] = '/') or (i = 1);
for h := 1 to i do
sama_n := sama_n + sciezka[h];
sama_nazwa_katalogu := sama_n;
end;

function duze_litery_PL(wers: ansistring): ansistring;
var
nowy: ansistring; i: cardinal; znak: char;
begin
nowy := '';
for i := 1 to length(wers) do
begin
znak := wers[i];
case znak of
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
end;
nowy := nowy + znak;
end;
nowy := UpperCase(nowy);
duze_litery_pl := nowy;
end;

function male_litery_PL(wers: ansistring): ansistring;
var
nowy: ansistring; i: cardinal; znak: char;
begin
nowy := '';
for i := 1 to length(wers) do
begin
znak := wers[i];
case znak of
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
'' : znak := '';
end;
nowy := nowy + znak;
end;
nowy := LowerCase(nowy);
male_litery_pl := nowy;
end;

function rozpoznaj_rozszerzenie_pliku(sciezka: ansistring): ansistring;
var
  i,h: cardinal; sama_n: ansistring;
begin
sama_n := '';
i := Length(sciezka);
repeat
i := i - 1;
until (sciezka[i] = '.') or (i = 1);
if sciezka[i] = '.' then i := i + 1;
for h := i to Length(sciezka) do
sama_n := sama_n + sciezka[h];
sama_n := UpperCase(sama_n); sama_n := Duze_litery_pl(sama_n);
rozpoznaj_rozszerzenie_pliku := sama_n;
end;

function plik_bez_rozszerzenia(ciag: ansistring): ansistring;
var i, HIT: cardinal; jot: ansistring;
begin
  i := length(ciag);
  repeat i := i - 1; until (ciag[i] = '.') or (i=1);
  jot := '';
  if ciag[i] = '.' then begin
  for hit := 1 to i -1 do
  jot := jot + ciag[hit];
  plik_bez_rozszerzenia := jot; end else
  plik_bez_rozszerzenia := ciag;
end;

function Podaj_sciezke_tego_programu: ansistring;
begin
  podaj_sciezke_tego_programu := sama_nazwa_katalogu(application.exename);
end;

function sprawdz_dostep_do_pliku(sciezka: ansistring): boolean;
var
  plik: TFileStream; zgoda: boolean;
begin
  zgoda := true;
  try plik := TFileStream.Create(sciezka, $0000);
  except
    zgoda := false;
  end;
  if zgoda = true then
  begin
   plik.Free;
   sprawdz_dostep_do_pliku := true;
  end else sprawdz_dostep_do_pliku := false;
end;

function rozmiar_pliku(sciezka: ansistring): cardinal;
var
 plik : TFileStream;
begin
  plik := TFileStream.Create(sciezka, $0000); rozmiar_pliku := plik.size;
  plik.Free;
end;


function Sprawdz_czy_sciezka_bezwzgledna(sciezka: ansistring): boolean;
var Sciezka_p, sieciowe: ansistring;
i : cardinal;
begin
 Sciezka_p := sciezka;
 for i := 1 to length(sciezka) do
 if sciezka_p[i] = '/' then sciezka_p[i] := '\';
 sieciowe := ''; sieciowe := sieciowe + sciezka_p[1];
 sieciowe := sieciowe + sciezka_p[2];
 if (sciezka_p[2] <> ':') and (sieciowe <> '\\') then
 sprawdz_czy_sciezka_bezwzgledna := true else
 sprawdz_czy_sciezka_bezwzgledna := false;
end;

Procedure Podaj_rgb(kolor: longint);
{procedura przekazuje wyniki na zmienne zadeklarowane
 globalnie: "czerwony", "zielony", "niebieski"...}
var
  kolor_t, c,z,n: ansistring;
begin
  kolor_t := IntToHex(kolor,6);
  c := ''; c := c + '$' + kolor_t[length(kolor_t)-1] + kolor_t[length(kolor_t)];
  z := ''; z := z + '$' +kolor_t[length(kolor_t)-3] + kolor_t[length(kolor_t)-2];
  n := ''; n := n + '$' +kolor_t[length(kolor_t)-5] + kolor_t[length(kolor_t)-4];
  czerwony := StrToInt(c); zielony := StrToInt(z); niebieski := StrToint(n);
  end;

procedure Szukaj_w_katalogu(miejsce, nazwa: ansistring);
var
wiersz, wiersz2: ansistring;
i, koniec: cardinal;
test : ansistring;
zezwalam, zaliczam : boolean;
begin
try
begin
  if ((miejsce[length(miejsce)] <> '\') or (miejsce[length(miejsce)] <> '/')) and (miejsce[2] = '\') then
  miejsce := miejsce + '\';
  data_mat.katalogi.directory := miejsce;
  koniec := data_mat.pliki.Items.Count - 1;
  for i := 0 to koniec do
  begin
  zezwalam := true;
  wiersz := data_mat.pliki.items[i];
  zaliczam := Szukaj_w_ciagu(nazwa, wiersz);
  if zaliczam = false then
  zezwalam := false;
  if (wiersz <> '[.]') and (wiersz <> '[..]') and (wiersz[1] = '[') then
  zezwalam := true;
  if zezwalam = true then
  begin
  if wiersz[1] = '[' then
  begin
  wiersz2 := data_mat.katalogi.directory;
  if (wiersz2[length(wiersz2)] <> '\') or (wiersz2[length(wiersz2)] <> '/')then
  wiersz2 := wiersz2 + '\';
  Szukaj_w_katalogu(wiersz2 + obrob_katalog(data_mat.pliki.items[i]),nazwa);
  data_mat.katalogi.Directory := wiersz2;
  end
  else
  begin
  wiersz2 := data_mat.katalogi.directory;
  if (wiersz2[length(wiersz2)] <> '\') or (wiersz2[length(wiersz2)] <> '\') then wiersz2 := wiersz2 + '\';
  wiersz2 := wiersz2 + data_mat.pliki.items[i];
  data_mat.lista_plikow.Items.Add(wiersz2);
  end;
  end;
  end;
  end;
  except
  exit;
  end;
end;

function Obrob_katalog(dest: ansistring): ansistring;
var
 i: cardinal;
 wyjsc: ansistring;
begin
   wyjsc := '';
   for i := 2 to Length(dest) - 1 do
   wyjsc := wyjsc + dest[i];
   obrob_katalog := wyjsc;
end;

function szukaj_w_ciagu(slowo_k: ansistring;ciag: ansistring): boolean;
var
ciag2, ciag3, fragment, hr1, hr2: ansistring;
i,z: integer; klops: cardinal;
zawiera: boolean;
begin
if length(slowo_k) <= length(ciag) then begin
    ciag2 := '';
    ciag3 := '';
klops := 0;
    repeat
    begin
    klops := klops + 1;
    zawiera := false;
    fragment := '';
    for z := KLOPS to Length(slowo_k) + KLOPS - 1 do
    fragment := fragment + ciag[z];
    hr1 := UpperCase(fragment);
    hr1 := Duze_litery_pl(hr1);
    hr2 := UpperCase(slowo_K);
    hr2 := duze_litery_pl(hr2);
    if hr1 = hr2 then
    zawiera := true;
end;
until (zawiera = true) or (klops = length(ciag) - length(slowo_k) + 1);
szukaj_w_ciagu := zawiera;
end else
szukaj_w_ciagu := false;
end;

procedure Szukaj_plikow_z_trescia(tresc,katalog: ansistring);
{procedura szuka plikw w ktrych nazwie znajduje si dana tre
 zadeklarowana w zmiennej "tresc". Pliki szukane s w katalogu deklarowanym
 w zmiennej "katalog" wraz z jego podkatalogami itd. ...
 Sciezki plikw wrzucane s do listy typu TLISTBOX o nazwie: "LISTA_PLIKOW"}
begin
  data_mat.LISTA_PLIKOW.Items.Add('OJOJ');
  data_mat.LISTA_PLIKOW.Clear;
  Szukaj_w_katalogu(katalog, tresc);
end;

end.
