unit grf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, Gauges;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Obraz1: TMenuItem;
    Plik1: TMenuItem;
    Otwrz1: TMenuItem;
    Zapisz1: TMenuItem;
    Otwrz2: TMenuItem;
    open: TOpenDialog;
    Maks_rozm: TLabel;
    otworz: TOpenDialog;
    Wycignijizapisz1: TMenuItem;
    save: TSaveDialog;
    Gauge1: TGauge;
    zapisz: TSaveDialog;
    Kodmaskujcy1: TMenuItem;
    Ustawkluczkodowania1: TMenuItem;
    N1: TMenuItem;
    Wytasuj1: TMenuItem;
    Poukadajjaktrzeba1: TMenuItem;
    N3: TMenuItem;
    Dowikszegokodowania1: TMenuItem;
    N2: TMenuItem;
    Kodujliniowo1: TMenuItem;
    Odkodujliniowo1: TMenuItem;
    N4: TMenuItem;
    Zrbnegatyw1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Kodujliniowopionowo1: TMenuItem;
    Odkodujliniowopionowo1: TMenuItem;
    N8: TMenuItem;
    Zrbnegatywlosowy1: TMenuItem;
    Zrbneagtyw1: TMenuItem;
    INFO1: TMenuItem;
    POKA1: TMenuItem;
    DokonajodwrceniaRGBzmiennegodziaawdwiestrony1: TMenuItem;
    Autor1: TMenuItem;
    N9: TMenuItem;
    N11Kodujobszarzobrazuobrmus1: TMenuItem;
    N11Kodujobszarzobrazywpliku1: TMenuItem;
    KODER: TOpenDialog;
    Image2: TImage;
    N1121: TMenuItem;
    N1231: TMenuItem;
    N10: TMenuItem;
    N15Nanasiebiedwaobrazyprzezplik1: TMenuItem;
    N16Zdejmijobrazzobrazu1: TMenuItem;
    N11: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Otwrz1Click(Sender: TObject);
    procedure Zapisz1Click(Sender: TObject);
function sprawdz_czy_sie_da(dlugosc_nazwy,x,y,rozm_p:cardinal):boolean;
    procedure Otwrz2Click(Sender: TObject);
    procedure koduj_do_obrazu;
    procedure Odczytaj_z_obrazu;
    procedure Wycignijizapisz1Click(Sender: TObject);
    procedure Ustawkluczkodowania1Click(Sender: TObject);
    procedure Wytasuj1Click(Sender: TObject);
    procedure Poukadajjaktrzeba1Click(Sender: TObject);
    procedure Kodujliniowo1Click(Sender: TObject);
    procedure Odkodujliniowo1Click(Sender: TObject);
    procedure Zrbnegatyw1Click(Sender: TObject);
    procedure Kodujliniowopionowo1Click(Sender: TObject);
    procedure Odkodujliniowopionowo1Click(Sender: TObject);
    procedure Zrbnegatywlosowy1Click(Sender: TObject);
    procedure Zrbneagtyw1Click(Sender: TObject);
    procedure POKA1Click(Sender: TObject);
    procedure DokonajodwrceniaRGBzmiennegodziaawdwiestrony1Click(
      Sender: TObject);
    procedure Autor1Click(Sender: TObject);
    procedure N11Kodujobszarzobrazuobrmus1Click(Sender: TObject);
    procedure N11Kodujobszarzobrazywpliku1Click(Sender: TObject);
    procedure N1121Click(Sender: TObject);
    procedure N1231Click(Sender: TObject);
    procedure N15Nanasiebiedwaobrazyprzezplik1Click(Sender: TObject);
    procedure N16Zdejmijobrazzobrazu1Click(Sender: TObject);
  private
    { Private declarations }
  public
     Image1 : Timage;
     sciezka : ansistring;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses klucz, data_m;

{$R *.DFM}

function tform1.sprawdz_czy_sie_da(dlugosc_nazwy,x,y,rozm_p:cardinal):boolean;
var
 naglowek,ilosc_bitow_w_ob:cardinal;
 tak : boolean;
begin
  ilosc_bitow_w_ob := (x * y * 3) div 8;
  naglowek := dlugosc_nazwy + 5;
  if ilosc_bitow_w_ob >= rozm_p + naglowek then
  tak := true else tak := false;
  sprawdz_czy_sie_da := tak;
end;
procedure TForm1.FormShow(Sender: TObject);
begin
  image1 := timage.create(Form1);
  image1.parent := Form1;
  image1.AutoSize := true;
  image1.left := 2;
  image1.top := 30;
  image1.height := 10;
  image1.width := 10;
  image1.show;
  form1.left := Screen.Width - Form1.Width - 30;
  form1.top := 30;
end;

procedure TForm1.Otwrz1Click(Sender: TObject);
var
 bity:cardinal;
begin
  if open.execute then
  begin
  image1.Destroy;
  image1 := timage.create(Form1);
  image1.parent := Form1;
  image1.AutoSize := true;
  image1.left := 2;
  image1.top := 30 + Gauge1.Height + 5;
  image1.height := 10;
  image1.width := 10;
  image1.show;
  image1.picture.loadfromfile(open.filename);
  bity := image1.width * Image1.height;
  bity := (bity * 3) div 8;
  bity := bity - 5 - 255;
  Maks_rozm.Caption := 'Maks. rozm. : ' + IntToStr(bity) + ' bajt., KB: ~ ' + IntToStr(bity div 1024);
  if Maks_rozm.width > form1.width + maks_rozm.left then form1.width := maks_rozm.left+maks_rozm.width+5;
  Gauge1.Width := maks_rozm.width;
end;
end;

procedure TForm1.Zapisz1Click(Sender: TObject);
begin
  if save.Execute then
  Image1.Picture.SaveToFile(save.filename);
end;

procedure TForm1.Otwrz2Click(Sender: TObject);
var
 p: Tfilestream; da_sie : boolean;
begin
if otworz.execute then
begin
p := TfileStream.Create(otworz.filename,$0000);
da_sie := sprawdz_czy_sie_da(length(sama_nazwa_pliku(otworz.filename)),image1.width, image1.height,p.size );
p.free;
sciezka := otworz.filename;
if da_sie = true then
koduj_do_obrazu else showmessage('Zbyt duy plik');
end;
end;

procedure tform1.koduj_do_obrazu;
var
 strumien,strumien2:tmemorystream; los: byte;
 plik:tfilestream;cz,zi,ni,bajt,dlugosc_nazwy:byte;
 nazwa:ansistring;rozmiar_pliku,x,y:cardinal;
  znak:char;
  bufx: bin;
begin
randseed := StrToInt(form2.edit1.text);
form1.caption := 'GRFX MG: krok 1/3';
form1.refresh;
strumien := TMemoryStream.Create;
gauge1.progress := 0; gauge1.maxvalue := image1.height div 8;
for y := 0 to Image1.Height - 1 do
begin
for x := 0 to Image1.Width - 1 do
begin
podaj_rgb(Image1.Canvas.Pixels[x,y]);
strumien.Write(czerwony,1);
strumien.Write(zielony,1);
strumien.Write(niebieski,1);
end;
gauge1.progress:=(y+1) div 8;
end;
strumien.position := 0;
strumien2 := TMemoryStream.create;
plik := tfilestream.create(sciezka, $0000);
nazwa := sama_nazwa_pliku(sciezka);
dlugosc_nazwy := length(nazwa);
rozmiar_pliku := plik.size;
strumien2.Write(rozmiar_pliku,4);
strumien2.write(dlugosc_nazwy,1);
for x := 1 to length(nazwa) do
begin
znak := nazwa[x]; bajt := Ord(znak);
strumien2.Write(bajt,1);
end;
strumien2.CopyFrom(plik,plik.size);
plik.free;
strumien2.position := 0;
form1.caption := 'GRFX MG: krok 2/3';
form1.refresh;
gauge1.progress := 0; gauge1.maxvalue := (strumien2.size) div 8;
for x := 1 to strumien2.size do
begin
strumien2.Read(bajt,1);
bufx := Na_Binarne(bajt);
for y := 1 to 8 do
begin
  los := Random(2);
if los = 1 then
  begin
  if bufx[y]=true then bufx[y]:=false else
  bufx[y] := true;
  end;
end;
for y := 1 to 8 do
begin
strumien.Read(bajt,1);
if (bajt=0) or (bajt=1) then
begin
if (bajt=0)and(bufx[y]=false)then
bajt:=bajt;
if(bajt=0)and(bufx[y]=true)then
bajt := 1;
if (bajt = 1)and(bufx[y]=false)then bajt:=0;
if(bajt=1)and(bufx[y]=true) then bajt := bajt;
end else
begin
if(bajt mod 2 = 0) and (bufx[y] =true) then bajt := bajt -1;
if (bajt mod 2 <> 0) and (bufx[y] =false) then bajt := bajt-1;
end;
strumien.position := strumien.position - 1; strumien.write(bajt,1);
end;
gauge1.progress := (strumien.position + 1) div 8;
end; strumien.position := 0; strumien2.free;
form1.caption := 'GRFX MG: krok 3/3';
form1.refresh;
gauge1.progress := 0;gauge1.maxvalue := image1.height div 8;
for y := 0 to image1.height-1 do
begin
for x:= 0 to image1.width-1 do
begin
strumien.read(cz,1);
strumien.read(zi,1);
strumien.read(ni,1);
image1.canvas.pixels[x,y] := rgb(cz,zi,ni);
end;
gauge1.progress := (y + 1)div 8;
end;
strumien.free;
form1.caption := 'GRFX MG: Kodowanie ukoczone';
end;


procedure tform1.Odczytaj_z_obrazu;
var
   strumien,strumien2:tmemorystream;
 plik,plik2:tfilestream;cz,zi,ni,bajt,dlugosc_nazwy:byte;
 nazwa:ansistring;rozmiar_pliku,x,y,kac:cardinal;
  znak:char; los: byte;hm:boolean;
  bufx: bin;
begin
   randseed := StrToInt(form2.edit1.text);
   strumien := TMemoryStream.create;
   form1.Caption := 'GRFX MG: krok 1/2';
   form1.refresh;
   gauge1.progress := 0; gauge1.maxvalue := image1.height div 15;
   for y := 0 to image1.height-1do
   begin
   for x := 0 to image1.width-1 do
   begin
   podaj_rgb(Image1.Canvas.pixels[x,y]);
   strumien.write(czerwony,1);
   strumien.write(zielony,1);
   strumien.write(niebieski,1);
   end;
   gauge1.progress := (y+1) div 15;
   end;
   strumien.position := 0;
   strumien2 := TmemoryStream.create;
   form1.Caption := 'GRFX MG: krok 2/2';
   form1.refresh;
   gauge1.progress := 0; gauge1.maxvalue := (strumien.size) div 15;
   for x:=1to strumien.size do
   begin
   for y:=1 to 8 do
   begin
   strumien.read(bajt,1);
   if bajt <= 1 then
   begin
   if bajt=1 then bufx[y] := true;
   if bajt=0 then bufx[y] := false;
   end else
   begin
   if bajt mod 2 <> 0 then bufx[y] := true
   else bufx[y] := false;
   end;
   end;
   for y := 1 to 8 do
begin
  los := Random(2);
  if los = 1 then
  begin
  if bufx[y]=true then bufx[y]:=false else
  bufx[y] := true;
  end;
end;
   bajt := Na_Dziesietne(bufx);
   strumien2.Write(bajt,1); gauge1.progress := (strumien2.size) div 15; end;
   strumien2.position := 0;
   strumien.free;
   strumien := TMemoryStream.Create;
   strumien2.read(rozmiar_pliku,4);
   strumien2.read(dlugosc_nazwy,1);
   nazwa := '';
   if dlugosc_nazwy <= strumien2.size - 5 then begin
   for y := 1 to dlugosc_nazwy do
   begin
   strumien2.read(bajt,1);
   znak := Chr(bajt);
   nazwa := nazwa + znak;
   end;
   end;
   if rozmiar_pliku <= strumien2.size - 5 then begin
   strumien.copyfrom(strumien2, rozmiar_pliku);
   end;
   strumien2.free;
   hm := true;
   try
   plik:=tfilestream.create(sama_nazwa_katalogu(sciezka)+nazwa,$FFFF);
   except
     hm:= false;
     strumien.position := 0;
     kac := 1024 * (Random(2057));
     if kac >= ((image1.width*image1.height*3) div 8)- 16 then kac := ((image1.width*image1.height*3) div 8)- 16;
     for y := 1 to kac do
     begin
       bajt := Random(256);
       strumien.Write(bajt,1);
     end;
       strumien.position := 0;
       plik2 := TfileStream.Create(sama_nazwa_katalogu(sciezka)+'[odkodowany].bxx2',$FFFF);
       plik2.copyfrom(strumien,strumien.size);
      plik2.free;
   end;
   if hm = true then
   begin
   strumien.position :=0;
   plik.copyfrom(strumien,strumien.size);
   plik.free;
   end;
   strumien.free; form1.caption := 'GRFX MG: Odczyt ukoczony';
end;

procedure TForm1.Wycignijizapisz1Click(Sender: TObject);
begin
 if zapisz.execute then
 begin
   form1.refresh;
   sciezka := zapisz.filename;
   odczytaj_z_obrazu;
 end;
end;

procedure TForm1.Ustawkluczkodowania1Click(Sender: TObject);
begin
  form2.ShowModal;
end;

procedure TForm1.Wytasuj1Click(Sender: TObject);
var
 x,y, los_x,los_y: word;
 kolor_oryg, kolor_los: Tcolor;
begin
  RandSeed := StrToInt(form2.edit1.text);
  gauge1.maxvalue := image1.height div 8;
  gauge1.progress := 0;
  for y := 0 to Image1.Height-1 do
  begin
    for x := 0 to Image1.Width -1 do
    begin
    kolor_oryg := image1.Canvas.Pixels[x,y];
    los_x := Random(Image1.Width);
    los_y := Random(image1.Height);
    kolor_los := Image1.Canvas.Pixels[los_x,los_y];
    Image1.Canvas.Pixels[x,y] := kolor_los;
    Image1.Canvas.pixels[los_x,los_y] := kolor_oryg;
 end;
    gauge1.progress := (y+1) div 8;
  end;
end;

procedure TForm1.Poukadajjaktrzeba1Click(Sender: TObject);
var
 x,y, los_x,los_y: word;
 kolor_oryg, kolor_los: Tcolor;
 pam: TMemoryStream;
 b:byte;
 begin
  pam := Tmemorystream.create;
  RandSeed := StrToInt(form2.edit1.text);
  Form1.Caption := 'GRFX MG: Krok 1\2';
  Form1.Refresh;
  gauge1.maxvalue := image1.height div 8;
  gauge1.progress := 0;
  for y := 0 to image1.height - 1 do
  begin
    for x := 0 to image1.width -1  do
    begin
      los_x := Random(image1.width);
      los_y:= Random(image1.height);
      pam.write(los_x,2);
      pam.Write(los_y,2);
    end;
    Gauge1.progress := (y+1) div 8;
  end;
  Form1.Caption := 'GRFX MG: Krok 2\2';
  Form1.Refresh;
  gauge1.maxvalue := image1.height div 8;
  gauge1.progress := 0;
  for y := 0 to Image1.Height-1 do
  begin
    for x := 0 to Image1.Width -1 do
    begin
    kolor_oryg := image1.Canvas.Pixels[Image1.width -1 -x,Image1.height -1 -y];
    pam.position := pam.position - 4;
    pam.read(los_x,2);
    pam.read(los_y,2);
    pam.position := pam.position - 4;
    kolor_los := Image1.Canvas.Pixels[los_x,los_y];
    Image1.Canvas.Pixels[Image1.width -1 -x,Image1.height -1 -y] := kolor_los;
    Image1.Canvas.pixels[los_x,los_y] := kolor_oryg;
 end;
    gauge1.progress := (y+1) div 8;
  end;
  pam.free;
  Form1.Caption := 'Dobre...ukoczone...';
end;

procedure TForm1.Kodujliniowo1Click(Sender: TObject);
var
  x,y,Y_los: word;
  kolor, kolor_los: Tcolor;
begin
RandSeed := StrToInt(form2.edit1.text);
gauge1.Progress := 0;
Gauge1.MaxValue := image1.height div 8;
for y := 0 to Image1.Height - 1 do
begin
  y_los := Random(image1.height);
  for x := 0 to Image1.Width - 1 do
  begin
    kolor := Image1.Canvas.Pixels[x,y];
    kolor_los := Image1.Canvas.pixels[x,Y_los];
    Image1.Canvas.Pixels[x,y] := kolor_los;
    Image1.Canvas.Pixels[x,y_los] := kolor;
  end;
  gauge1.progress := (y+1) div 8;
  end;

end;

procedure TForm1.Odkodujliniowo1Click(Sender: TObject);
var
  x,y,Y_los: word;
  kolor, kolor_los: Tcolor;
  pam : TmemoryStream;
begin
RandSeed := StrToInt(form2.edit1.text);
{}
Form1.Caption := 'Krok 1\2';
Form1.Refresh;
gauge1.Progress := 0;
Gauge1.MaxValue := image1.height div 8;
pam := tmemorystream.create;
for y := 0 to Image1.height-1 do
begin
 y_los := Random(image1.height);
 pam.Write(Y_los,2);
 Gauge1.progress := (y+1) div 8;
end;


{}
Form1.Caption := 'Krok 2\2';
Form1.Refresh;
gauge1.Progress := 0;
for y := 0 to Image1.Height - 1 do
begin
  pam.position := pam.position - 2;
  pam.read(y_los,2);
  pam.position := pam.position - 2;
  for x := 0 to Image1.Width - 1 do
  begin
    kolor := Image1.Canvas.Pixels[x,image1.height-1-y];
    kolor_los := Image1.Canvas.pixels[x,Y_los];
    Image1.Canvas.Pixels[x,image1.height-1-y] := kolor_los;
    Image1.Canvas.Pixels[x,y_los] := kolor;
  end;
  gauge1.progress := (y+1) div 8;
  end;
  pam.free;
  Form1.Caption := 'odkodowywanie zakoczone...';
end;

procedure TForm1.Zrbnegatyw1Click(Sender: TObject);
var
  c,z,n: byte;
  x,y: word;
begin
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height div 8;
   for y := 0 to Image1.Height-1 do
   begin
     for x := 0 to Image1.Width - 1 do
     begin
       podaj_rgb(Image1.Canvas.Pixels[x,y]);
      {w pascalu} {c := 255 - czerwony; z := 255 - zielony; n := 255 - niebieski;}
       {\/ w assemblerze na przerwaniach \/}
       asm
         mov AL, czerwony
         NOT AL
         mov c, AL
         mov AL, zielony
         NOT AL
         mov z, AL
         mov AL, niebieski
         NOT AL
         mov n, AL
       end; 
       Form1.Image1.Canvas.Pixels[x,y] := rgb(c,z,n);
     end;
     Gauge1.progress := (y+1) div 8;
   end;
end;

procedure TForm1.Kodujliniowopionowo1Click(Sender: TObject);
var
  x,y,x_los: word;
  kolor, kolor_los: Tcolor;
begin
RandSeed := StrToInt(form2.edit1.text);
gauge1.Progress := 0;
Gauge1.MaxValue := (image1.width) div 8;
for x := 0 to Image1.width - 1 do
begin
  x_los := Random(image1.width);
  for y := 0 to Image1.height - 1 do
  begin
    kolor := Image1.Canvas.Pixels[x,y];
    kolor_los := Image1.Canvas.pixels[x_los,Y];
    Image1.Canvas.Pixels[x,y] := kolor_los;
    Image1.Canvas.Pixels[x_los,y] := kolor;
  end;
  gauge1.progress := (x+1) div 8;
  end;
end;

procedure TForm1.Odkodujliniowopionowo1Click(Sender: TObject);
var
  x,y,x_los: word;
  kolor, kolor_los: Tcolor;
  pam : TmemoryStream;
begin
RandSeed := StrToInt(form2.edit1.text);
{}
Form1.Caption := 'Krok 1\2';
Form1.Refresh;
gauge1.Progress := 0;
Gauge1.MaxValue := image1.width div 8;
pam := tmemorystream.create;
for x := 0 to Image1.width-1 do
begin
 x_los := Random(image1.width);
 pam.Write(x_los,2);
 Gauge1.progress := (x+1) div 8;
end;


{}
Form1.Caption := 'Krok 2\2';
Form1.Refresh;
gauge1.Progress := 0;
for x := 0 to Image1.width - 1 do
begin
  pam.position := pam.position - 2;
  pam.read(x_los,2);
  pam.position := pam.position - 2;
  for y := 0 to image1.height - 1 do
  begin
      kolor := Image1.Canvas.Pixels[image1.width-1-x,y];
    kolor_los := Image1.Canvas.pixels[x_los,y];
    Image1.Canvas.Pixels[image1.width-1-x,y] := kolor_los;
    Image1.Canvas.Pixels[x_los,y] := kolor;
  end;
  gauge1.progress := x+1;
  end;
  pam.free;
  Form1.Caption := 'odkodowywanie zakoczone...';
end;

procedure TForm1.Zrbnegatywlosowy1Click(Sender: TObject);
var
  c,z,n, ok: byte;
  x,y: word;
begin
   RandSeed := StrToInt(form2.edit1.text);
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height div 8;
   for y := 0 to Image1.Height-1 do
   begin
     for x := 0 to Image1.Width - 1 do
     begin
       ok := random(2);
       if ok > 0 then
       begin
       podaj_rgb(Image1.Canvas.Pixels[x,y]);
       c := 255 - czerwony; z := 255 - zielony; n := 255 - niebieski;
       Image1.Canvas.Pixels[x,y] := rgb(c,z,n);
       end;
     end;
     Gauge1.progress := (y+1) div 8;
   end;
end;

procedure TForm1.Zrbneagtyw1Click(Sender: TObject);
var
  c,z,n,ok: byte;
  x,y: word;
begin
   RandSeed := StrToInt(form2.edit1.text);
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height;
   for y := 0 to Image1.Height-1 do
   begin
     ok := Random(2);
     for x := 0 to Image1.Width - 1 do
     begin
       if ok < 1 then begin
       podaj_rgb(Image1.Canvas.Pixels[image1.width - 1 -x,image1.height-1-y]);
       c := 255 - czerwony; z := 255 - zielony; n := 255 - niebieski;
       Image1.Canvas.Pixels[image1.width - 1 -x,image1.height-1-y] := rgb(c,z,n);
       end;
     end;
     Gauge1.progress := (y+1) div 8;
   end;
end;

procedure TForm1.POKA1Click(Sender: TObject);
begin
  ShowMessage('Do kadego kodowania losowego uywany jest kod maskujcy...');
end;

procedure TForm1.DokonajodwrceniaRGBzmiennegodziaawdwiestrony1Click(
  Sender: TObject);
var
  c,z,n: byte;
  x,y: word;
begin
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height div 8;
   for y := 0 to Image1.Height-1 do
   begin
     for x := 0 to Image1.Width - 1 do
     begin
       podaj_rgb(Image1.Canvas.Pixels[x,y]);
       c := niebieski; z := zielony; n := czerwony;
       Image1.Canvas.Pixels[x,y] := rgb(c,z,n);
     end;
     Gauge1.progress := (y+1) div 8;
   end;
end;

procedure TForm1.Autor1Click(Sender: TObject);
begin
  ShowMessage('Wkurzajcy Joe');
end;

procedure TForm1.N11Kodujobszarzobrazuobrmus1Click(Sender: TObject);
var
 x,y: word;
 kod,kod2,kod3: integer;
begin
  if koder.execute then
  begin
  Image2.Picture.LoadFromFile(koder.filename);
  gauge1.maxvalue := (image1.height) div 8;
  gauge1.Progress := 0;
  Form1.Refresh;
  for y := 0 to image1.height-1 do
  begin
    for x := 0 to image1.width - 1 do
    begin
      if (x < Image2.Width - 1) and (y < Image2.height - 1) then
      RandSeed := Image2.Canvas.pixels[x,y] else
      RandSeed := 56748;
      podaj_rgb(image1.Canvas.Pixels[x,y]);
      kod := czerwony+1;
      kod2 := zielony+1;
      kod3 := niebieski+1;
      kod := kod + Random(256);
      kod2 := kod2 + Random(237);
      kod3 := kod3 + Random(186);
      if kod > 256 then kod := kod - 256;
      if kod2 > 256 then kod2 := kod2 - 256;
      if kod3 > 256 then kod3 := kod3 - 256;
      kod := kod-1;
      kod2 := kod2-1;
      kod3 := kod3-1;
      czerwony := kod;
      zielony := kod2;
      niebieski := kod3;
      Image1.Canvas.Pixels[x,y] := rgb(czerwony,zielony,niebieski);
    end;
  gauge1.progress := y+1;
  end;
  end;
end;

procedure TForm1.N11Kodujobszarzobrazywpliku1Click(Sender: TObject);
var
 x,y: word;
 kod,kod2,kod3: integer;
begin
 if koder.execute then
  begin
  Image2.Picture.LoadFromFile(koder.filename);
  gauge1.maxvalue := image1.height;
  gauge1.Progress := 0;
  for y := 0 to image1.height-1 do
  begin
    for x := 0 to image1.width - 1 do
    begin
       if (x < Image2.Width - 1) and (y < Image2.height - 1) then
      RandSeed := Image2.Canvas.pixels[x,y] else
      RandSeed := 56748;
      podaj_rgb(image1.Canvas.Pixels[x,y]);
      kod := czerwony+1;
      kod2 := zielony+1;
      kod3 := niebieski+1;
      kod := kod - Random(256);
      kod2 := kod2 - Random(237);
      kod3 := kod3 - Random(186);
      if kod <= 0 then kod := 256 + kod;
      if kod2 <= 0 then kod2 := 256 + kod2;
      if kod3 <= 0 then kod3 := 256 + kod3;
      kod := kod-1;
      kod2 := kod2-1;
      kod3 := kod3-1;
      czerwony := kod;
      zielony := kod2;
      niebieski := kod3;
      Image1.Canvas.Pixels[x,y] := rgb(czerwony,zielony,niebieski);
    end;
  gauge1.progress := y+1;
  end;
  end;
end;

procedure TForm1.N1121Click(Sender: TObject);
var
  c,z,n: byte;
  x,y: word;
begin
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height;
   for y := 0 to Image1.Height-1 do
   begin
     for x := 0 to Image1.Width - 1 do
     begin
       podaj_rgb(Image1.Canvas.Pixels[x,y]);
       c := czerwony; z := niebieski; n := zielony;
       Image1.Canvas.Pixels[x,y] := rgb(c,z,n);
     end;
     Gauge1.progress := y+1;
   end;
end;

procedure TForm1.N1231Click(Sender: TObject);
var
  c,z,n: byte;
  x,y: word;
begin
   Gauge1.progress := 0;
   Gauge1.MaxValue := Image1.Height;
   for y := 0 to Image1.Height-1 do
   begin
     for x := 0 to Image1.Width - 1 do
     begin
       podaj_rgb(Image1.Canvas.Pixels[x,y]);
       c := zielony; z := czerwony; n := niebieski;
       Image1.Canvas.Pixels[x,y] := rgb(c,z,n);
     end;
     Gauge1.progress := y+1;
   end;
end;

procedure TForm1.N15Nanasiebiedwaobrazyprzezplik1Click(Sender: TObject);
var
 x,y: word;
 kod,kod2,kod3: integer;
 c,z,n: byte;
begin
  if koder.execute then
  begin
  Form1.Refresh;
  Image2.Picture.LoadFromFile(koder.filename);
  gauge1.maxvalue := image1.height;
  gauge1.Progress := 0;
  Form1.Refresh;
  for y := 0 to image1.height-1 do
  begin
    for x := 0 to image1.width - 1 do
    begin
      if (x < Image2.Width - 1) and (y < Image2.height - 1) then
      begin
      podaj_rgb(Image2.Canvas.Pixels[x,y]);
      c := czerwony; z := zielony; n := niebieski;
      podaj_rgb(image1.canvas.pixels[x,y]);
      end else
      begin
         c := 0; z := 0; n := 0;
         podaj_rgb(image1.canvas.pixels[x,y]);
      end;
      kod := czerwony+1;
      kod2 := zielony+1;
      kod3 := niebieski+1;
      kod := kod + c;
      kod2 := kod2 + z;
      kod3 := kod3 + n;
      if kod > 256 then kod := kod - 256;
      if kod2 > 256 then kod2 := kod2 - 256;
      if kod3 > 256 then kod3 := kod3 - 256;
      kod := kod-1;
      kod2 := kod2-1;
      kod3 := kod3-1;
      czerwony := kod;
      zielony := kod2;
      niebieski := kod3;
      Image1.Canvas.Pixels[x,y] := rgb(czerwony,zielony,niebieski);
    end;
  gauge1.progress := y+1;
  end;
  end;
end;

procedure TForm1.N16Zdejmijobrazzobrazu1Click(Sender: TObject);
var
 x,y: word;
 kod,kod2,kod3: integer;
 c,z,n: byte;
begin
  if koder.execute then
  begin
  Image2.Picture.LoadFromFile(koder.filename);
  gauge1.maxvalue := image1.height;
  gauge1.Progress := 0;
  Form1.Refresh;
  for y := 0 to image1.height-1 do
  begin
    for x := 0 to image1.width - 1 do
    begin
      if (x < Image2.Width - 1) and (y < Image2.height - 1) then
      begin
      podaj_rgb(Image2.Canvas.Pixels[x,y]);
      c := czerwony; z := zielony; n := niebieski;
      podaj_rgb(image1.canvas.pixels[x,y]);
      end else
      begin
         c := 0; z := 0; n := 0;
         podaj_rgb(image1.canvas.pixels[x,y]);
      end;
      kod := czerwony+1;
      kod2 := zielony+1;
      kod3 := niebieski+1;
      kod := kod - c;
      kod2 := kod2 - z;
      kod3 := kod3 - n;
      if kod <= 256 then kod := 256 + kod;
      if kod2 <= 256 then kod2 := 256 + kod2;
      if kod3 <= 256 then kod3 := 256 + kod3;
      kod := kod-1;
      kod2 := kod2-1;
      kod3 := kod3-1;
      czerwony := kod;
      zielony := kod2;
      niebieski := kod3;
      Image1.Canvas.Pixels[x,y] := rgb(czerwony,zielony,niebieski);
    end;
  gauge1.progress := y+1;
  end;
  end;

end;

end.
